// 
//  Copyright 2008 OCP-IP
//
// ============================================================================
//      Project : OCP SLD WG
//       Author : Anssi Haverinen, Nokia Inc.
//                Robert Guenzel (from TU of Braunschweig) for Greensocs Ltd.
//           $Id: master.h,v 1.2 2005/01/07 03:42:33 Anssi Exp $
//
//  Description : OCP - TL1 profile example
//
// ============================================================================

#ifndef _OCP_TL1_MASTER_SYNC_H
#define _OCP_TL1_MASTER_SYNC_H

// Turn on debug messages
//#define DEBUG_G1

#include <iostream>
#include "stdlib.h"

// OCP-IP Channel header files
#include "ocpip.h"

class Master : public sc_core::sc_module
{
public:  
  
  typedef ocpip::ocp_data_class_unsigned<32,32>::DataType Td;
  typedef ocpip::ocp_data_class_unsigned<32,32>::AddrType Ta;

  // channel port
  typedef ocpip::ocp_master_socket_tl1<32> m_socket_type;
  m_socket_type ipP;

  // TL1 clock
  sc_core::sc_in_clk  clk;

  SC_HAS_PROCESS(Master);

  // constructor
  Master(sc_core::sc_module_name name_);

  // destructor
  ~Master();

  // threads
  void proc();

  tlm::tlm_sync_enum nb_transport(tlm::tlm_generic_payload& txn, tlm::tlm_phase& ph, sc_core::sc_time& tim);

  int cnt;

  // Request group
  tlm::tlm_generic_payload* req;
  bool ongoing_req;
  tlm::tlm_generic_payload* resp;  
  Ta addrCnt;
  Td dataCnt;
  tlm::tlm_phase phase;
  sc_core::sc_time time; 
};


#endif // _OCP_TL1_MASTER_SYNC_H
