// 
//  (c) Copyright OCP-IP 2003, 2004
//  OCP-IP Confidential and Proprietary
//
// ============================================================================
//      Project : OCP SLD WG, Layer adapter examples 
//      Authors : Yann Bajot, PROSILOG, bajot@prosilog.com 
//                Stephane Guntz, PROSILOG, guntz@prosilog.com
//
//  Description : Layer Adapter, TL0-TL1 example, Synchronous TL0 OCP Master
//                with Datahandshake support (OCP 2.0)
//  $Id: ocp_tl0_master_sync_hs.h,v 1.1.1.1 2004/09/24 09:26:13 sguntz Exp $
//
// ============================================================================

#ifndef _TL0_OCP_MASTER_SYNC_HS_H
#define _TL0_OCP_MASTER_SYNC_HS_H

#include "systemc.h"
#include "ocp_globals.h"

using namespace std;

// ----------------------------------------------------------------------------
// Class : OCP_TL0_Master_sync_hs 
// 
// Description: Synchronous TL0 OCP Master 
// ----------------------------------------------------------------------------

template <class TdataCl> class OCP_TL0_Master_sync_hs
  : public sc_module
{
public:

  typedef typename TdataCl::DataType Td;
  typedef typename TdataCl::AddrType Ta;

  // Basic OCP ports
  sc_in   <bool>      Clk;

  sc_out  <sc_bv<3> >	MCmd;
  sc_out 	<Ta>      	MAddr;
  sc_in	  <bool>	    SCmdAccept;

  sc_out  <bool>	    MDataValid;
  sc_out 	<Td>      	MData;
  sc_in  <bool>	      SDataAccept;

  sc_in	  <Td>      	SData;
  sc_in	  <sc_bv<2> > SResp;
  sc_out 	<bool>	    MRespAccept;

  SC_HAS_PROCESS(OCP_TL0_Master_sync_hs);

  // constructor
  OCP_TL0_Master_sync_hs(sc_module_name name_
            , sc_time RequestDelay = sc_time(0)
            , sc_time DataDelay = sc_time(0)
            , sc_time ResponseDelay = sc_time(0)
           );

  // destructor
  ~OCP_TL0_Master_sync_hs();

  // methods
  void GetResponse();
  void SendRequest();

  // Master parameters
  sc_time   m_RequestDelay;
  sc_time   m_DataDelay;
  sc_time   m_ResponseDelay;

};


#endif // _TL0_OCP_MASTER_ASYNC_H
