
void process_command_line(int   argc,
                          char* argv[],
                          string& ocp_params_file_name,
			  bool& use_event,
			  bool& use_default_event,
			  std::string& monFileName1,
			  std::string& monFileName2,
			  std::string& monFileName3
			  )
{
    // get the ocp parameters file name
    ocp_params_file_name = "";
    if (argc > 1) {
      string name1(argv[1]);
      ocp_params_file_name = name1;
    }
    if (argc > 2) {
      string name2(argv[2]);
      use_event = (bool)atoi(name2.c_str());
    }
    else
      use_event = false;
    if (argc > 3) {
      string name3(argv[3]);
      use_default_event = (bool)atoi(name3.c_str());
    }
    else
      use_default_event = false;
  
    if (argc > 4) {
      string name4(argv[4]);
      monFileName1 = name4;
    }
    else
      monFileName1 = "";
    if (argc > 5) {
      string name5(argv[5]);
      monFileName2 = name5;
    }
    else
      monFileName2 = "";
    if (argc > 6) {
        string name6(argv[6]);
	monFileName3 = name6;
    }
    else
      monFileName3 = "";

}
void readMapFromFile(const string &myFileName, MapStringType &myParamMap) 
{
    // read pairs of data from the passed file
    string leftside;
    string rightside;
    
    // (1) open the file
    ifstream inputfile(myFileName.c_str());
    assert( inputfile );

    // set the formatting
    inputfile.setf(std::ios::skipws);

    // Now read through all the pairs of values and add them to the passed map
    while ( inputfile ) {
        inputfile >> leftside;
        inputfile >> rightside;
        myParamMap.insert(std::make_pair(leftside,rightside));
    }

    // All done, close up
    inputfile.close();
}

